Index: java/main/src/test/resources/info/GenePool.info
===================================================================
--- java/main/src/test/resources/info/GenePool.info	(revision 105)
+++ java/main/src/test/resources/info/GenePool.info	(revision 105)
@@ -0,0 +1,103 @@
+class:
+id:GenePool
+
+prop:
+id:name
+name:Group name
+type:s
+
+prop:
+id:index
+name:group index
+type:d
+flags:35
+
+prop:
+id:size
+name:Number of items in the group
+type:d
+flags:3
+help:In standard.expdef, this is equivalent to the number of unique genotypes. Standard experiment definition uses the Genotype.instances field to indicate that some genotypes exist in multiple instances despite having only one item in the group. Other experiment definitions may create multiple copies of the same genotype.
+
+prop:
+id:totalpop
+name:Number of genotype instances
+type:d
+flags:3
+help:Takes into account the Genotype.instances field (which may give the total number of instances depending on the experiment definition).
+
+prop:
+id:fitness
+name:Fitness formula
+type:s 1
+help:(intended for advanced users)
+
+prop:
+id:fitfun
+name:Scale fitness?
+type:d 0 1 0
+help:Enables fitness scaling.
+
+prop:
+id:fitm
+name:Shift coefficient
+type:f 0 10 2
+help:~
+Lower threshold: how many standard deviations below average?
+(avg - n * stddev) - used for fitness shifting~
+
+prop:
+id:fitma
+name:Scaling coefficient
+type:f 1 10 2
+help:~
+The best genotype is as many times
+better than the average one.~
+
+prop:
+id:get
+name:get Genotype object
+type:p oGenotype(d index)
+flags:34
+
+prop:
+id:findGeno
+name:find Genotype index
+type:p d(oGeno)
+flags:34
+help:~
+Finds the Genotype matching the supplied Geno object.
+returns genotype index or -1 if not found.~
+
+prop:
+id:findUID
+name:find Genotype by UID
+type:p d(s uid)
+flags:34
+
+prop:
+id:addGeno
+name:make Genotype from Geno
+type:p oGenotype(oGeno)
+flags:34
+help:~
+Creates a new Genotype from the supplied Geno object.
+Returns the created Genotype.~
+
+prop:
+id:delete
+name:
+type:p(d genotype index)
+flags:34
+help:Deletes a genotype.
+
+prop:
+id:genotypes
+name:Genotypes
+type:l Genotype uid
+
+prop:
+id:genotypes_changed
+name:genotype list changed
+type:e ListChange
+
Index: java/main/src/test/resources/info/Population.info
===================================================================
--- java/main/src/test/resources/info/Population.info	(revision 105)
+++ java/main/src/test/resources/info/Population.info	(revision 105)
@@ -0,0 +1,232 @@
+class:
+id:Population
+
+prop:
+id:index
+name:group index
+type:d
+flags:35
+
+prop:
+id:name
+name:Group name
+type:s
+
+prop:
+id:size
+name:Number of creatures
+type:d
+flags:3
+
+prop:
+id:energy
+name:Energy calculation
+type:d 0 1 1
+help:If turned off, creature's energy will be constant.
+
+prop:
+id:death
+name:Death
+type:d 0 1 1
+help:Do creatures die when no energy?
+
+prop:
+id:nnsim
+name:Neural net simulation
+type:d 0 2 1 ~Off~Immediate~After stabilization
+help:Stabilization means no significant movement during a specified period of time.
+
+prop:
+id:perfperiod
+name:Performance sampling period
+type:d 0 1000000 100
+help:Defines how often onUpdate() events are called. Also used to compute partial performance of creatures (distance, speed, etc.) and to determine stabilization.
+
+prop:
+id:stabilperiod
+name:Sampling period while waiting
+type:d 0 1000000 100
+help:"Performance sampling period" for the stabilization phase.
+
+prop:
+id:killnostable
+name:Kill if no stabilization after
+type:d 0 10000000 1000000
+help:Creatures that fail to stabilize after the specified waiting period (e.g. because they are continuously rolling) will be killed. 0 disables this feature.
+
+prop:
+id:stabledist
+name:Allowed distance to be stable
+type:f 0 1 0.01
+help:A creature is considered stabilized when its center of gravity stays within the specified distance after the "Sampling period while waiting" has elapsed.
+
+prop:
+id:enableperf
+name:Performance calculation
+type:d 0 2 1 ~Off~Immediate~After stabilization
+help:Stabilization means no significant movement during a specified period of time.
+
+prop:
+id:colmask
+name:Collision mask (deprecated)
+type:db 0 65535 0
+flags:32
+help:DEPRECATED. You should use selfmask and othermask (these masks are also much easier to understand than the old colmask field).
+
+prop:
+id:selfmask
+name:Collision mask (self)
+type:db 0 2147483647 0
+flags:32
+help:~
+Collisions between objects can be handled in two ways:
+ - standard 'mechanical' collision (simple 'rebound' effect)
+ - special script handler (On[GROUPNAME]Collision function)
+
+In the script handler function, use the Collision object to access the two colliding parts of two creatures.
+The first part in the Collision object (i.e. Collision.Creature1) always concerns the creature that belongs to [GROUPNAME].
+The handler is called once for each creature that collides with the creature from [GROUPNAME].
+
+Collision masks determine which one will be used (none and both are also possible). On each collision, selfmask and othermask of the colliding objects are logically ANDed. 16 lower bits (0xffff) enable the standard handler. 16 higher bits (0xffff0000) enable the custom handler.
+Examples:
+
+1.With one group, all possible combinations of the collision handlers are as follows:
+  - ignore collisions (e.g. selfmask=othermask=0)
+  - use standard handling (e.g. selfmask=othermask=1)
+  - use custom handling (e.g. selfmask=othermask=0x10000)
+  - use standard and custom handling (e.g. selfmask=othermask=0x10001)
+
+2.Two groups yield more interesting cases. Let us consider the 'standard.expdef' setting:
+  Creatures: selfmask=0x10001, othermask=0x20001
+  Food colmask = selfmask=0x20002, othermask=0x10002
+There are three possible scenarios:
+- creature and creature: collision value = 0x10001 & 0x20001 = 1 -> Standard handling will be used (1 is one of the lower 16 bits)
+- food and food: collision value = 0x20002 & 0x10002 = 2 -> As above.
+- creature and food: collision value = (0x10001 & 0x10002) or (0x20002 & 0x20001) = 0x10000 or 0x20000 -> Custom handling will be used (higher 16 bits).
+~
+
+prop:
+id:othermask
+name:Collision mask (other)
+type:db 0 2147483647 0
+flags:32
+help:See selfmask.
+
+prop:
+id:bodysim
+name:Body simulation
+type:d 0 1 1
+help:Enable/disable physical body simulation. This is the initial value of Creature.bodysim for all objects created in this group. For details, see the documentation of Creature.bodysim.
+
+prop:
+id:selfcol
+name:Detect self-collisions
+type:d 0 1 0
+help:Detect collisions within creature bodies (only applicable for the ODE simulation engine). This is the initial value of Creature.selfcol for all objects created in this group. If enabled, creatures with self-colliding genotypes are not born, and others will have their sticks collide during lifespan.
+
+prop:
+id:em_stat
+name:Muscle static work
+type:f 0 1 0
+help:~
+Energy requirements for a muscle
+resisting an external force~
+
+prop:
+id:em_dyn
+name:Muscle dynamic work
+type:f 0 1 0
+help:~
+Energy requirements for a muscle
+moving a stick~
+
+prop:
+id:en_assim
+name:Assimilation productivity
+type:f 0 1 0
+help:~
+Maximal energy gain produced by a vertical specialized stick.
+Horizontal specialized sticks get half of this value.~
+
+prop:
+id:createFromGenotype
+name:
+type:p oCreature()
+flags:34
+help:Uses the selected Genotype object
+
+prop:
+id:createFromString
+name:
+type:p oCreature(s genotype)
+flags:34
+help:Uses the supplied string argument
+
+prop:
+id:createFromGeno
+name:
+type:p oCreature(oGeno)
+flags:34
+help:Uses the supplied Geno object
+
+prop:
+id:findUID
+name:find creature by UID
+type:p d(s uid)
+flags:34
+
+prop:
+id:get
+name:get creature object
+type:p oCreature(d index)
+flags:34
+
+prop:
+id:senseCreaturesProperty
+name:senseCreaturesProperty
+type:p f(f x,f y,f z,s propertyname,oCreature exclude)
+flags:34
+help:~
+arguments:
+ - x,y,z (sensor position)
+ - property (name, name[index] or Class:id). name[index] can be used for Vector objects inside the user fields, eg "user2[10]"
+ - exclude (creature object)
+works like a smell sensor for a given property (for all creatures in this group except "exclude").
+The following function reproduces the "classic" framsticks "S" sensor:
+function smellReceptorValue(x,y,z,exclude)
+{
+var i,s=0; for(i=0;i<Populations.size;i++)
+	s+=Populations[0].senseCreaturesProperty(x,y,z,"energy",exclude);
+return s;
+}~
+
+prop:
+id:findCreatureAt
+name:
+type:p oCreature(oVector point,oVector vector)
+flags:34
+
+prop:
+id:delete
+name:
+type:p(d creature index)
+flags:34
+help:delete creature
+
+prop:
+id:kill
+name:
+type:p(d creature index)
+flags:34
+help:kill creature
+
+prop:
+id:creatures
+name:Creatures
+type:l Creature uid
+
+prop:
+id:creatures_changed
+name:creatures list changed
+type:e ListChange
+